﻿DROP TABLE IF EXISTS pois;

CREATE TABLE pois (id serial primary key, name varchar(150), geom geometry(Point,4326), closest_node_id bigint, closest_osm_id bigint, edge_id integer, fraction float4);

SELECT id, name geom, closest_node_id, closest_osm_id FROM pois;

INSERT INTO pois(name, geom)
VALUES 
	('Seaport Hotel & World Trade Center', ST_SetSRID(ST_Point(-71.0415884,42.3491639),4326)),
	('Airport', ST_SetSRID(ST_Point(-71.0198579,42.3662416),4326)),
	('Harpoon Brewery', ST_SetSRID(ST_Point(-71.0341060,42.3471542),4326)),
	('New England Aquarium', ST_SetSRID(ST_Point(-71.04969,42.35920),4326)),
	('Harvard CGIS Knafel', ST_SetSRID(ST_Point(-71.1134454,42.3755432),4326)),
	('MIT', ST_SetSRID(ST_Point(-71.0950742,42.3597494),4326));

UPDATE pois SET (closest_node_id, closest_osm_id) = (SELECT id, osm_id FROM osm.ways_vertices_pgr ORDER BY the_geom <-> pois.geom LIMIT 1);


UPDATE pois 
SET (edge_id, fraction) = 
    (SELECT e.gid,  ST_LineLocatePoint(ST_Transform(e.the_geom,26986), ST_Transform(pois.geom,26986))
    FROM osm.ways E INNER JOIN osm.ways_vertices_pgr N 
    ON E.source = N.id 
    ORDER BY E.the_geom <-> pois.geom LIMIT 1);

-- Compare how far off closest node is to matching edge
SELECT P.*, E.source, E.target 
FROM pois P INNER JOIN osm.ways E ON P.edge_id = E.gid;
